<template>
    <div v-if="entities !== undefined && Object.keys(entities).length > 0">
        <div class="table-responsive">
            <table class="table table-striped">
                <tr>
                    <th><input type="checkbox" :checked="allChecked" @input="toggleAllCheckbox" class="form-check-input"></th>
                    <th>Nome</th>
                    <th v-for="column in extraColumns">{{column.name}}</th>
                    <th>Stato</th>
                    <th>Azione</th>
                </tr>
                <synctable-tr
                        v-for="(entity, id) in entities"
                        :entity="entity"
                        :entity-type="entityType"
                        :key="id"
                        :id="String(id)"
                        :checked="checked.indexOf(String(id)) > -1"
                        :extra-columns="extraColumns"
                        :show-main-action-btn="showMainAction"
                        :show-delete-btn="showDeleteAction"
                        :main-action-btn-label="mainActionLabel"
                        :initial-state-label="initialStateLabel"
                        @main-btn-click="queueAction($event)"
                        @delete-btn-click="deleteEntity($event)"
                        @checkboxclicked="checkboxClicked"
                        ref="children"
                ></synctable-tr>
            </table>
        </div>
        <button class="btn btn-primary" v-if="showMainAction" :disabled="checked.length < 1" @click="queueSelectedForDefaultAction">{{ mainActionLabel }} selezionati</button>
        <button class="btn btn-danger ms-2" v-if="showDeleteAction" :disabled="checked.length < 1" @click="deleteSelected">Elimina selezionati</button>

        <teleport to="body">
        <div class="modal" tabindex="-1" :class="{show: entitiesToDelete.length > 0, 'd-block': entitiesToDelete.length > 0}">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Opzioni per l'eliminazione</h5>
                        <button type="button" class="btn-close" aria-label="Close" @click="entitiesToDelete=[]"></button>
                    </div>
                    <div class="modal-body">
                        <form class="row row-cols-lg-auto g-3 align-items-center">
                            <form class="form">
                                <div class="form-check mb-0" v-if="entityType === 'students' || entityType === 'teachers' || entityType === 'groups'">
                                    <input type="checkbox" class="form-check-input" :id="'syncComp-deleteLdap'+entityType" :checked="deleteOptions.deleteOnLdap" @input="(event) => setDeleteOption('deleteOnLdap',event.target.checked)">
                                    <label class="form-check-label" :for="'syncComp-deleteLdap'+entityType">Elimina da Ldap</label>
                                </div>
                                <div class="form-check mb-0 pl-0" v-if="entityType === 'groups'">
                                    <input type="checkbox" class="form-check-input" :id="'syncComp-deleteGapps'+entityType" :checked="deleteOptions.deleteOnGApps==='1'" @input="(event) => setDeleteOption('deleteOnGApps',event.target.checked?'1':'0')">
                                    <label class="form-check-label" :for="'syncComp-deleteGapps'+entityType">Elimina da Google Apps</label>
                                </div>
                                <div class="d-flex gap-2 align-items-center" v-if="entityType === 'students' || entityType === 'teachers'">
                                    <label class="text-nowrap" :for="'deleteOnGApps'+entityType">Elimina su Google Apps</label>
                                    <select class="form-select" :id="'deleteOnGApps'+entityType" :value="deleteOptions.deleteOnGApps" @input="(event) => setDeleteOption('deleteOnGApps',event.target.value)">
                                        <option value="0">No</option>
                                        <option value="1">Si</option>
                                        <option value="2">Sposta in OU</option>
                                    </select>
                                </div>
                                <div class="d-flex gap-2 align-items-center" v-if="(entityType === 'students' || entityType === 'teachers') && deleteOptions.deleteOnGApps === '2'">
                                    <label :for="'gAppsOu'+entityType">OU</label>
                                    <input type="text" class="form-control" :id="'gAppsOu'+entityType" :value="deleteOptions.gAppsOu" @input="(event) => setDeleteOption('gAppsOu',event.target.value)">
                                </div>
                            </form>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" @click="entitiesToDelete=[]">Annulla</button>
                        <button type="button" class="btn btn-danger" @click="queueDeleteActions">Elimina</button>
                    </div>
                </div>
            </div>
        </div>
        </teleport>
    </div>
</template>

<script>
import SyncTableTr from "./SyncTableTr.vue";
import axios from "axios";

export default {
    name: "SyncTable",
    props: {
        entities: {type: Object},
        entityType: {type: String},
        defaultAction: {type: String},
        defaultDeleteOptions: {type: Object},
        url: {type: String},
        deleteUrl: {type: String, default: null},
        mainActionLabel: {type: String, default: 'Esegui'},
        showMainAction: {type: Boolean, default: true},
        showDeleteAction: {type: Boolean, default: false},
        extraColumns: {type: Array, default: []},
        initialStateLabel: {type: String, default: '---'}
    },
    data: function () {
        return {
            checked: [],
            allChecked: false,
            deleteOptions: {...this.defaultDeleteOptions},
            executionQueue: [],
            queueWorking: false,
            entitiesToDelete: []
        }
    },
    methods: {
        checkboxClicked: function (id) {
            var pos = this.checked.indexOf(id);
            if (pos > -1) {
                this.checked.splice(pos, 1);
            } else {
                this.checked.push(id);
            }
        },
        toggleAllCheckbox: function () {
            this.checked = [];
            if (!this.allChecked) {
                for (let child of this.$refs.children) {
                    if (!child.disabled) {
                        this.checked.push(child.id);
                    }
                }
            }
            this.allChecked = !this.allChecked;
        },
        callAction: function (payload) {
            if (typeof payload !== 'object' ||
                payload.entityId === undefined ||
                payload.entityType === undefined ||
                payload.entity === undefined ||
                payload.action === undefined
            ) {
                console.warn("Invalid call action payload", payload);
                return;
            }

            payload.entity.state = 2;

            let url = this.url;
            if(payload.action === "delete") {
                url = this.deleteUrl;
            }

            if (url === "") {
                return;
            }

            if(typeof payload.entity.data.providerId !== "undefined") {
                url = url.replace("*providerId*",payload.entity.data.providerId);
            }

            const $this = this;
            let data = {
                entityData: payload.entity.data,
                entityId: payload.entityId,
                entityType: payload.entityType,
            };

            if(payload.action === "delete") {
                if(payload.deleteOptions === undefined) {
                    console.warn("Invalid call action payload options", payload);
                    return;
                }
                data['options'] = payload.deleteOptions;
            }

            axios.post(url, data,{
                headers: {
                    'Content-Type': 'multipart/form-data'
                }
            }).then(function (response) {
                if (typeof response.data !== "object" || response.data.success !== true) {
                    throw typeof response.data === 'object' && response.data.error !== undefined ? response.data.error : null;
                }

                payload.entity.state = 3;
                if (response.data.newEntityId !== undefined) {
                    this.$emit('newEntityInserted', {...payload, newEntityId: response.data.newEntityId});
                }

                $this.queueWorking = false;
                $this.tickQueue();
            }).catch(function (err) {
                payload.entity.error = typeof err === "string" ? err : "Impossibile elaborare la richiesta";
                payload.entity.state = 0;
                $this.queueWorking = false;
                $this.tickQueue();
            });
        },
        queueSelectedForDefaultAction: function () {
            for (let entityIdIdx in this.checked) {
                this.queueAction(this.checked[entityIdIdx]);
            }

            this.checked = [];
        },
        deleteEntity(entityId) {
            if(this.entityType === 'students' || this.entityType === 'teachers' || this.entityType === 'groups') {
                this.entitiesToDelete = [entityId];
                return;
            }

            this.queueAction(entityId, 'delete');
        },
        deleteSelected() {
            if(this.entityType === 'students' || this.entityType === 'teachers' || this.entityType === 'groups') {
                this.entitiesToDelete = this.checked;
                return;
            }

            for (let entityId of this.checked) {
                this.queueAction(entityId, 'delete');
            }
            this.checked = [];
        },
        queueDeleteActions() {
            for (let entityId of this.entitiesToDelete) {
                this.queueAction(entityId, 'delete');
            }

            this.entitiesToDelete = [];
            this.checked = [];
        },
        queueAction: function (entityId, action=null) {
            if (this.entities[entityId].state > 0) {
                return;
            }

            this.entities[entityId].state = 1;
            this.entities[entityId].error = null;

            this.executionQueue.push({
                action: action !== null ? action : this.defaultAction,
                entityId: entityId,
                entityType: this.entityType,
                entity: this.entities[entityId],
                deleteOptions: this.deleteOptions
            });

            this.tickQueue();
        },
        tickQueue: function () {
            if (this.queueWorking || this.executionQueue.length < 1) {
                return;
            }

            const $this = this;
            $this.queueWorking = true;

            setTimeout(function () {
                $this.callAction($this.executionQueue.shift());
            }, 0);
        },
        setDeleteOption(key, value) {
            this.deleteOptions[key] = value;
        }
    },
    components: {
        'synctable-tr': SyncTableTr
    }
}
</script>

<style lang="scss" scoped>

</style>